/[gentoo-x86]/eclass/ruby-ng.eclass
Gentoo

Diff of /eclass/ruby-ng.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.24
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/ruby-ng.eclass,v 1.21 2010/07/08 04:00:57 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/ruby-ng.eclass,v 1.24 2010/07/30 16:56:21 flameeyes Exp $
4# 4#
5# @ECLASS: ruby-ng.eclass 5# @ECLASS: ruby-ng.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ruby herd <ruby@gentoo.org> 7# Ruby herd <ruby@gentoo.org>
8# 8#
51EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_test src_install pkg_setup 51EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_test src_install pkg_setup
52 52
53case ${EAPI} in 53case ${EAPI} in
54 0|1) 54 0|1)
55 die "Unsupported EAPI=${EAPI} (too old) for ruby-ng.eclass" ;; 55 die "Unsupported EAPI=${EAPI} (too old) for ruby-ng.eclass" ;;
56 2) ;; 56 2|3) ;;
57 *) 57 *)
58 die "Unknown EAPI=${EAPI} for ruby-ng.eclass" 58 die "Unknown EAPI=${EAPI} for ruby-ng.eclass"
59esac 59esac
60 60
61# @FUNCTION: ruby_implementation_depend 61# @FUNCTION: ruby_implementation_depend
389 type all_ruby_test &>/dev/null && \ 389 type all_ruby_test &>/dev/null && \
390 _ruby_invoke_environment all all_ruby_test 390 _ruby_invoke_environment all all_ruby_test
391} 391}
392 392
393_each_ruby_check_install() { 393_each_ruby_check_install() {
394 local scancmd=scanelf
395 # we have a Mach-O object here
396 [[ ${CHOST} == *-darwin ]] && scancmd=scanmacho
397
398 has "${EAPI}" 2 && ! use prefix && EPREFIX=
399
394 local libruby_basename=$(${RUBY} -rrbconfig -e 'puts Config::CONFIG["LIBRUBY_SO"]') 400 local libruby_basename=$(${RUBY} -rrbconfig -e 'puts Config::CONFIG["LIBRUBY_SO"]')
395 local libruby_soname=$(scanelf -qS "/usr/$(get_libdir)/${libruby_basename}" | awk '{ print $1 }') 401 local libruby_soname=$(basename $(${scancmd} -F "%S#F" -qS "${EPREFIX}/usr/$(get_libdir)/${libruby_basename}"))
396 local sitedir=$(${RUBY} -rrbconfig -e 'puts Config::CONFIG["sitedir"]') 402 local sitedir=$(${RUBY} -rrbconfig -e 'puts Config::CONFIG["sitedir"]')
397 local sitelibdir=$(${RUBY} -rrbconfig -e 'puts Config::CONFIG["sitelibdir"]') 403 local sitelibdir=$(${RUBY} -rrbconfig -e 'puts Config::CONFIG["sitelibdir"]')
398 404
399 # Look for wrong files in sitedir 405 # Look for wrong files in sitedir
400 if [[ -d "${D}${sitedir}" ]]; then 406 # if [[ -d "${D}${sitedir}" ]]; then
401 local f=$(find "${D}${sitedir}" -mindepth 1 -maxdepth 1 -not -wholename "${D}${sitelibdir}") 407 # local f=$(find "${D}${sitedir}" -mindepth 1 -maxdepth 1 -not -wholename "${D}${sitelibdir}")
402 if [[ -n ${f} ]]; then 408 # if [[ -n ${f} ]]; then
403 eerror "Found files in sitedir, outsite sitelibdir:" 409 # eerror "Found files in sitedir, outsite sitelibdir:"
404 eerror "${f}" 410 # eerror "${f}"
405 die "Misplaced files in sitedir" 411 # die "Misplaced files in sitedir"
406 fi 412 # fi
407 fi 413 # fi
408 414
409 # The current implementation lacks libruby (i.e.: jruby) 415 # The current implementation lacks libruby (i.e.: jruby)
410 [[ -z ${libruby_soname} ]] && return 0 416 [[ -z ${libruby_soname} ]] && return 0
411 417
412 scanelf -qnR "${D}${sitedir}" \ 418 # Check also the gems directory, since we could be installing compiled
419 # extensions via ruby-fakegem; make sure to check only in sitelibdir, since
420 # that's what changes between two implementations (otherwise you'd get false
421 # positives now that Ruby 1.9.2 installs with the same sitedir as 1.8)
422 ${scancmd} -qnR "${D}${sitelibdir}" "${D}${sitelibdir/site_ruby/gems}" \
413 | fgrep -v "${libruby_soname}" \ 423 | fgrep -v "${libruby_soname}" \
414 > "${T}"/ruby-ng-${_ruby_implementation}-mislink.log 424 > "${T}"/ruby-ng-${_ruby_implementation}-mislink.log
415 425
416 if [[ -s "${T}"/ruby-ng-${_ruby_implementation}-mislink.log ]]; then 426 if [[ -s "${T}"/ruby-ng-${_ruby_implementation}-mislink.log ]]; then
417 ewarn "Extensions installed for ${_ruby_implementation} with missing links to ${libruby_soname}" 427 ewarn "Extensions installed for ${_ruby_implementation} with missing links to ${libruby_soname}"
446# @USAGE: file [file...] 456# @USAGE: file [file...]
447# @DESCRIPTION: 457# @DESCRIPTION:
448# Installs the specified file(s) into the sitelibdir of the Ruby interpreter in ${RUBY}. 458# Installs the specified file(s) into the sitelibdir of the Ruby interpreter in ${RUBY}.
449doruby() { 459doruby() {
450 [[ -z ${RUBY} ]] && die "\$RUBY is not set" 460 [[ -z ${RUBY} ]] && die "\$RUBY is not set"
461 has "${EAPI}" 2 && ! use prefix && EPREFIX=
451 ( # don't want to pollute calling env 462 ( # don't want to pollute calling env
452 insinto $(ruby_rbconfig_value 'sitelibdir') 463 sitelibdir=$(ruby_rbconfig_value 'sitelibdir')
464 insinto ${sitelibdir#${EPREFIX}}
453 insopts -m 0644 465 insopts -m 0644
454 doins "$@" 466 doins "$@"
455 ) || die "failed to install $@" 467 ) || die "failed to install $@"
456} 468}
457 469

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.24

  ViewVC Help
Powered by ViewVC 1.1.20